;---------------------------------------------------------------------
;   Floating Point
;   2000/11/04 Jun Mizutani
;   calc.asm
;---------------------------------------------------------------------

%include "stdio.inc"
%include "float.inc"
%include "readline.inc"

%assign         MAXLINE 256
%assign         MAXWORD 256

%assign         OP_NULL 0
%assign         OP_ADD  1
%assign         OP_SUB  2
%assign         OP_MUL  3
%assign         OP_DIV  4
%assign         OP_ATAN 5

;==============================================================
section .text
global _start

_start:
                finit                           ; FPU 
                call    GET_TERMIOS             ; termios ¸
                call    SET_TERMIOS             ; üΥ륨OFF
                fldz                            ; 0 FPU˥
                mov    byte[level], 0           ; 쥸å٥
ReadLine:       ; 1
                mov     eax, prompt             ; ץץɽ
                call    OutAsciiZ
                mov     eax, MAXLINE            ; 1 
                mov     ebx, input
                call    READ_LINE
                mov     ecx, MAXLINE            ; 
                mov     esi, input
                call    LineCleaner
                mov     eax, esi                ; CHECK!!
                mov     byte[operation], OP_NULL
                xor     ebx, ebx                ; ⥪եå = 0
Parse:          ; Բ
                mov     eax, 0x20               ; 򥹥å
                mov     ecx, MAXLINE            ; reserved
                mov     esi, input
                call    SkipChar
                mov     eax, 0x20               ; 
                mov     edi, wordbuf
                call    Word1
                jb      ReadLine
                cmp     edx, 0
                jz      ReadLine                ; empty

                mov     al, [edi]
                cmp     al, "0"                 ; 
                jb      .command
                cmp     al, "9"
                ja      .command
                jmp     .num                    ; 0 - 9 ʤ

.command        ; 1ʸޥ
                cmp     edx, 1
                jne     near .num               ; 1ʸʾϿ
                cmp     al, 'Q'                 ; Q, q ʤнλ
                jne     .com1
                call    RESTORE_TERMIOS         ; termios 
                call    Exit
.com1
                cmp     al, '.'                 ; ͤβǽͭ
                jne     .com2
                dec     ebx                     ; 1ʸ᤹(ungetc)
                jmp     .num
.com2
                cmp     al, '+'                 ; û
                jne     .com3
                mov     byte[operation], OP_ADD
                jmp     Parse
.com3
                cmp     al, '-'                 ; 
                jne     .com4
                mov     byte[operation], OP_SUB
                jmp     Parse
.com4
                cmp     al, '*'                 ; 軻
                jne     .com5
                mov     byte[operation], OP_MUL
                jmp     Parse
.com5
                cmp     al, '/'                 ; 
                jne     .com6
                mov     byte[operation], OP_DIV
                jmp     Parse
.com6
                cmp     al, '='                 ; ͤɽ
                jne     .com7
                fld     st0                     ; ʣ (DUP)
                call    print_float             ; ɽ
                jmp     Parse

.com7
                cmp     al, 'D'                 ; åɽ
                jne     .com8
                mov     eax, '<'
                call    OutChar
                fstsw   ax
                shr     eax, 11
                and     eax, 0x07
                call    PrintLeft               ; ɽ
                mov     eax, '>'
                call    OutChar
                call    NewLine
                jmp     Parse
.com8
                cmp     al, 'R'                 ; ʿ
                jne     .com9
                fsqrt
                jmp     Parse
.com9
                cmp     al, 'S'                 ; 
                jne     .com10
                fsin
                jmp     Parse
.com10
                cmp     al, 'C'                 ; 
                jne     .com11
                fcos
                jmp     Parse
.com11
                cmp     al, 'T'                 ; 󥸥
                jne     .com12
                fptan
                jmp     Parse
.com12
                cmp     al, '$'                 ; 󥸥
                jne     .com13
                mov     byte[operation], OP_ATAN
                jmp     Parse
.com13
                cmp     al, 'P'                 ; 
                jne     .com14
                cmp     byte[operation], OP_NULL
                jne     .com13_1
                ffree   st0                     ;
                fincstp
.com13_1:       fldpi
                jmp     .op_add
.com14
                cmp     al, 'H'                 ; إɽ
                jne     .com15
                mov     eax, help1
                call    OutAsciiZ
                mov     eax, help2
                call    OutAsciiZ
                mov     eax, help3
                call    OutAsciiZ
                mov     eax, help4
                call    OutAsciiZ
                mov     eax, help5
                call    OutAsciiZ
                jmp     Parse
.com15
                jmp     Parse

.num            ; 
    .op_num:    mov     eax, wordbuf
                call    Ascii2Float      ; ưʸFPU˥å
                jb      near .num_err           ; Ѵ顼
                cmp     byte[operation], OP_NULL
                jne     .op_add
                fxch                            ; åĴ
                ffree   st0
                fincstp                         ; pop

    .op_add:    cmp     byte[operation], OP_ADD
                jne     .op_sub
                faddp   st1,st0
                mov     byte[operation], OP_NULL
                jmp     Parse
    .op_sub:    cmp     byte[operation], OP_SUB
                jne     .op_mul
                fsubp   st1,st0
                mov     byte[operation], OP_NULL
                jmp     Parse
    .op_mul:    cmp     byte[operation], OP_MUL
                jne     .op_div
                fmulp   st1,st0
                mov     byte[operation], OP_NULL
                jmp     Parse
    .op_div:    cmp     byte[operation], OP_DIV
                jne     .op_atan
                fdivp   st1,st0
                mov     byte[operation], OP_NULL
                jmp     Parse
    .op_atan:   cmp     byte[operation], OP_ATAN
                jne     .op_end
                fpatan                          ; atan(st1/st0)
                mov     byte[operation], OP_NULL
                jmp     Parse
    .op_end:
                jmp     Parse
.num_err
                mov     eax, numerror           ; Ѵ顼ɽ
                call    OutAsciiZ
                mov     eax, wordbuf
                call    OutAsciiZ
                call    NewLine
                jmp     Parse

;------------------------------------
; FPU Υåȥåפư쥸ʸѴɽ
; åȥåפ POP (Ѵ) 롥ɬפʤ DUP 롥
print_float
                mov     edi, fstring
                call    Float2Ascii
                mov     eax, ' '
                call    OutChar
                mov     eax, fstring
                call    OutAsciiZ
                call    NewLine
                ret

;--------------------------------------------------------------
; esi ǻꤵ, Ĺ ecx ʸХåեΰʸѴ
; ѾʸϱʸTAB  SPACE, LF  0 Ѵ롥
; ecx : buffer length        (reserved)
; esi : buffer start address (reserved)
;--------------------------------------------------------------
LineCleaner:
                jcxz    .lc_end
                push    esi
                push    ecx
        .next
                mov     al, [esi]
                or      al, al
                jz      .lc_end
                cmp     al, 0x09                ; TAB
                jne     .lc_lf
                mov     byte [esi], 0x20        ; SPACE
                jmp     short .skip
        .lc_lf
                cmp     al, 0x0A                ; Line feed
                jne     .lc_upper
                mov     byte [esi], 0           ; 0
                jmp     short .skip
        .lc_upper
                cmp     al, 0x60
                jb      .skip
                cmp     al, 0x7B
                jae     .skip
                sub     al, 0x20
                mov     byte [esi], al          ; uppercase
        .skip
                inc     esi
                loop    .next
        .lc_end
                pop     ecx
                pop     esi
                ret

;--------------------------------------------------------------
; esi ǻꤵʸХåեΰΥեå ebx 
; al ǻꤵʸɤФơal ʳʸޤ
; ebx ʤ. ХåեΰĶȲ⤷ʤ
; al  : skip character       (reserved)
; ebx : start offset within buffer, return new offset
; ecx : buffer length        (reserved)
; esi : buffer start address (reserved)
;--------------------------------------------------------------
SkipChar:
        .skip
                cmp     ebx, ecx
                jns     .skipend
                cmp     al, [esi + ebx]
                jne     .skipend
                inc     ebx
                jmp     .skip
        .skipend
                ret

;--------------------------------------------------------------
; ڤʸ, , ԥХåեޤǤʸ
; edi θХåե˥ԡ
; Хåեʸ 0 
; ԥХåե򤹤٤ƻȤä饭꡼å
; ԡʸĹ(0ޤޤʤ)  edx ֤
; eax : delimiter
; ebx : start offset within buffer, return new offset
; ecx : line buffer length (reserved)
; edx : return word length
; esi : line buffer start address (reserved)
; edi : word buffer start address (reserved)
; Set CF=1, if line buffer contains no data.
;--------------------------------------------------------------
Word1:
                xor     edx, edx
        .word
                cmp     ebx, ecx
                jns     .wend                   ; ϰϳ ?
                mov     ah, [ebx + esi]
                or      ah, ah                  ; 0 ?
                je      .wend
                inc     ebx
                cmp     ah, al                  ; ڤʸ
                jne     .copy
                or      edx, edx
                jne     .wend
                jmp     short .word
        .copy
                mov     [edx + edi], ah
                inc     edx
                jmp     short .word
        .wend
                mov     byte [edx + edi], 0
                or      edx, edx
                je      .empty
                clc
                ret
        .empty
                stc
                ret

;--------------------------------------------------------------
; ߤ termios ¸
GET_TERMIOS:
                pusha
                mov     ebx, old_termios
                call    tcgetattr
                mov     ecx,  new_termios - old_termios
                mov     esi,  old_termios
                mov     edi,  new_termios
                rep
                movsb
                popa
                ret

;--------------------------------------------------------------
;  termios 
; Raw⡼, ECHO ̵, ECHONL ̵
; VTIME=0, VMIN=1 : 1Хɤ߼ޤԵ
SET_TERMIOS:
                pusha
                mov     eax, [new_termios.c_lflag]
                and     eax, ~ICANON & ~ECHO & ~ECHONL
                or      eax, ISIG
                mov     [new_termios.c_lflag], eax
                mov     eax, 1
                mov     [new_termios.c_cc + VMIN], al
                mov     eax, 0
                mov     [new_termios.c_cc + VTIME], al
                mov     ebx, new_termios
                call    tcsetattr
                popa
                ret

;--------------------------------------------------------------
; ¸Ƥ termios 
RESTORE_TERMIOS:
                pusha
                mov     ebx, old_termios
                call    tcsetattr
                popa
                ret

;--------------------------------------------------------------
; ɸϤ termios μ
; tcgetattr(&termios)
; tcsetattr(&termios)
; eax : destroyed
; ebx : termios buffer adress
; ecx, edx : destroyed
tcgetattr:
                mov     eax, TCGETS
                jmp     short IOCTL

tcsetattr:
                mov     eax, TCSETS

;--------------------------------------------------------------
; ɸϤ ioctl μ¹
; sys_ioctl(unsigned int fd, unsigned int cmd,
;           unsigned long arg)
; eax : cmd
; ebx : buffer adress
IOCTL:
                mov     ecx, eax            ; set cmd
                mov     edx, ebx            ; set arg
                mov     eax, 54             ; sys_ioctl
                mov     ebx, 0              ; to stdin
                int     0x80                ; call kernel
                ret

;==============================================================
section .bss

fstring         resb 32
input           resb MAXLINE
wordbuf         resb MAXWORD
operation       resb 1

old_termios     istruc termios
                  .c_iflag    UINT   1       ; input mode flags
                  .c_oflag    UINT   1       ; output mode flags
                  .c_cflag    UINT   1       ; control mode flags
                  .c_lflag    UINT   1       ; local mode flags
                  .c_line     UCHAR  1       ; line discipline
                  .c_cc       UCHAR  NCCS    ; control characters
                iend

new_termios     istruc termios
                  .c_iflag    UINT   1       ; input mode flags
                  .c_oflag    UINT   1       ; output mode flags
                  .c_cflag    UINT   1       ; control mode flags
                  .c_lflag    UINT   1       ; local mode flags
                  .c_line     UCHAR  1       ; line discipline
                  .c_cc       UCHAR  NCCS    ; control characters
                iend
new_termios_end

;==============================================================
section .data

level           db   0
prompt          db   'calc>',0
help1           db   ' LineEdit  ^H:BS  ^D:Delete  ^B:Back  ^F:Forward', 0x0A, 0
help2           db   ' Function  R:SquareRoot  S:Sine  C:Cosine', 0x0A, 0
help3           db   '           T:Tangent  $:atan(a/b)= a $ b  P:Pi', 0x0A, 0
help4           db   ' Display   =:Result   D:StackLevel  H:Help', 0x0A, 0
help5           db   ' Quit      Q', 0x0A, 0
numerror        db   ' Error>',0
