;=========================================================================
; DEBUG
; file : debug.inc
; 2000/12/09
;         Copyright (C) 2000 Jun Mizutani <mizutani.jun@nifty.ne.jp>
;=========================================================================
%ifndef __DEBUG_INC
%define __DEBUG_INC

%include "stdio.inc"

;=========================================================================
;-------------------------------------------------------------------------
; \
;   .  CHECK 'Waw!'  ; 4܂
;-------------------------------------------------------------------------
%macro CHECK 1
                push    eax
                mov     eax, %1
                call    check_point
                pop     eax
%endmacro

;-------------------------------------------------------------------------
; Register \
;   .  REGS
;-------------------------------------------------------------------------
%macro REGS  0
                call    print_regs
%endmacro

;-------------------------------------------------------------------------
; w肵̓e16i10iŕ\
;   .  MEM1    [work]  ; work 1oCg̓e\
;        MEM2    [work]  ; work 2oCg̓e\
;        MEM4    [work]  ; work 4oCg̓e\
;-------------------------------------------------------------------------
%macro MEM1  1
                pushfd
                push    eax
                push    ebx
                xor     eax, eax
                mov     al, %1
                lea     ebx, %1
                call    print_mem1
                pop     ebx
                pop     eax
                popfd
%endmacro

%macro MEM2  1
                pushfd
                push    eax
                push    ebx
                xor     eax, eax
                mov     ax, %1
                lea     ebx, %1
                call    print_mem2
                pop     ebx
                pop     eax
                popfd
%endmacro

%macro MEM4  1
                pushfd
                push    eax
                push    ebx
                mov     eax, %1
                lea     ebx, %1
                call    print_mem4
                pop     ebx
                pop     eax
                popfd
%endmacro

;=========================================================================
section .text

;-------------------------------------------------------------------------
; \
; ex.  check 'Waw!'  4܂
;-------------------------------------------------------------------------
check_point:
                pushfd
                push    edx
                push    eax
                mov     eax, CheckMsg
                call    OutAsciiZ
                pop     eax
                call    OutChar4
                mov     al, ')'
                call    OutChar
                call    NewLine
                pop     edx
                popfd
                ret

;-------------------------------------------------------------------------
; Register \
;-------------------------------------------------------------------------
print_regs:
                pushfd
                push    edx
                push    eax
                call    NewLine
                push    edx                     ; EDX ۑ
                push    eax
                mov     eax, 'EAX:'             ; EAX WX^\
                call    OutChar4
                pop     eax
                call    PrintHex8
                call    .PrintDecimal

                mov     eax, 'EBX:'             ; EBX WX^\
                call    OutChar4
                mov     eax, ebx
                call    PrintHex8
                call    .PrintDecimal

                mov     eax, 'ECX:'             ; ECX WX^\
                call    OutChar4
                mov     eax, ecx
                call    PrintHex8
                call    .PrintDecimal

                mov     eax, 'EDX:'             ; EDX WX^\
                call    OutChar4
                pop     eax                     ; ۑĂEDX
                call    PrintHex8
                call    .PrintDecimal

                mov     eax, 'EDI:'             ; EDI WX^\
                call    OutChar4
                mov     eax, edi
                call    PrintHex8
                call    .PrintDecimal

                mov     eax, 'ESI:'             ; ESI WX^\
                call    OutChar4
                mov     eax, esi
                call    PrintHex8
                call    .PrintDecimal

                mov     eax, 'EBP:'             ; EBP WX^\
                call    OutChar4
                mov     eax, ebp
                call    PrintHex8
                call    .PrintDecimal

                mov     eax, 'ESP:'             ; ESP WX^\
                call    OutChar4
                mov     eax, esp
                call    PrintHex8
                call    .PrintDecimal
                pop     eax
                pop     edx
                popfd
                ret
.PrintDecimal
                push    eax
                mov     eax, ' '
                call    OutChar
                pop     eax
                call    PrintLeft
                call    NewLine
                ret

;-------------------------------------------------------------------------
; w肵̓e16i10iŕ\
;-------------------------------------------------------------------------
print_mem1:
                push    edx
                push    eax
                call    NewLine
                mov     eax, 'MEM:'
                call    OutChar4
                mov     eax, ebx
                call    PrintHex8
                mov     eax, ' '
                call    OutChar
                pop     eax
                call    PrintHex2
                call    print_regs.PrintDecimal
                pop     edx
                ret

print_mem2:
                push    edx
                push    eax
                call    NewLine
                mov     eax, 'MEM:'
                call    OutChar4
                mov     eax, ebx
                call    PrintHex8
                mov     eax, ' '
                call    OutChar
                pop     eax
                call    PrintHex4
                call    print_regs.PrintDecimal
                pop     edx
                ret

print_mem4:
                push    edx
                push    eax
                call    NewLine
                mov     eax, 'MEM:'
                call    OutChar4
                mov     eax, ebx
                call    PrintHex8
                mov     eax, ' '
                call    OutChar
                pop     eax
                call    PrintHex8
                call    print_regs.PrintDecimal
                pop     edx
                ret

;-------------------------------------------------------------------------
; EDI 10oCg(80bit)̃e16iŕ\
; ̌㕔ʌ
;-------------------------------------------------------------------------
print_mem80:
                pushfd
                push    ecx
                mov     ecx, 10
          .loop
                mov     al, [edi+ecx-1]
                push    edx
                call    PrintHex2
                pop     edx
                loop    .loop
                pop     ecx
                popfd
                ret

;-------------------------------------------------------------------------
; EDI 10oCg(80bit)̃e16iŕ\
; ̑Oʌ
;-------------------------------------------------------------------------
print_10:
                pushfd
                push    edi
                push    ecx
                mov     ecx, 10
          .loop
                mov     al, [edi]
                call    PrintHex2
                inc     edi
                loop    .loop
                pop     ecx
                pop     edi
                popfd
                ret

;-------------------------------------------------------------------------
; FPU ̃X^bNgbv16iŕ\
;     1 - 99 ܂ł̐\\C FFFFC000000000000000 ƂȂ
;-------------------------------------------------------------------------
print_top:
                pushfd
                push    edx
                push    eax
                push    edi
                fld     st0   ; DUP
                fstp    tword [BCD0] ; stack topw胁10byteɊi[
                mov     edi, BCD0
                call    print_mem80
                mov     eax, ':'
                call    OutChar
                fld     st0   ; DUP
                fbstp   tword [BCD0] ;stack topBCD18Ń10byteɊi[
                mov     edi, BCD0
                call    print_mem80
                call    NewLine
                pop     edi
                pop     eax
                pop     edx
                popfd
                ret

;-------------------------------------------------------------------------
; FPU ̃XeC^X[hS16iŕ\
;-------------------------------------------------------------------------
print_fpu_status:
                pushfd
                push    eax
                fnstsw  ax
                push    edx
                shr     eax, 11
                and     eax, 7
                call    PrintHex4
                call    NewLine
                pop     edx
                pop     eax
                popfd
                ret

;-------------------------------------------------------------------------
CheckMsg           db 10, 'CHECK(', 0

;=========================================================================
section .bss

BCD0            rest    1       ; l BCD \(10oCg)

%endif
