;---------------------------------------------------------------------
; 2000/07/21  forkexec.asm
; nasm -f elf forkexec.asm
; ld -s -o forkexec forkexec.o
; ndisasm -b 32 forkexec
;---------------------------------------------------------------------

%include "resource.inc"
%include "vartype.inc"
%include "syscall.inc"
%include "stdio.inc"

section .bss
        argc    resd    1
        argvp   resd    1
        envp    resd    1

section .data

ru:  istruc  rusage
        .ru_utime_tv_sec   _LONG  0 ;  user time used
        .ru_utime_tv_usec  _LONG  0 ;
        .ru_stime_tv_sec   _LONG  0 ;  system time used
        .ru_stime_tv_usec  _LONG  0 ;
        .ru_maxrss         _LONG  0 ;  maximum resident set size
        .ru_ixrss          _LONG  0 ;  integral shared memory size
        .ru_idrss          _LONG  0 ;  integral unshared data size
        .ru_isrss          _LONG  0 ;  integral unshared stack size
        .ru_minflt         _LONG  0 ;  page reclaims
        .ru_majflt         _LONG  0 ;  page faults
        .ru_nswap          _LONG  0 ;  swaps
        .ru_inblock        _LONG  0 ;  block input operations
        .ru_oublock        _LONG  0 ;  block output operations
        .ru_msgsnd         _LONG  0 ;  messages sent
        .ru_msgrcv         _LONG  0 ;  messages received
        .ru_nsignals       _LONG  0 ;  signals received
        .ru_nvcsw          _LONG  0 ;  voluntary context switches
        .ru_nivcsw         _LONG  0 ;  involuntary
    iend

title     db    "fork & execve.", 0
title2    db    "fork & execve with wrong envp.", 0
parent    db    "Back to Parent Process. Child pid was:", 0
child     db    "Child Process execve ./stackdump", 0
timemsg   dd    " System time in usec :", 0
stat_addr dd    0
command   db    "./stackdump", 0
arg1      dd    0
argv      dd    arg1, 0
fakeenv1  db    "WRONG=1",0
fakeenvp  dd    fakeenv1,0

section .text
global _start

_start:
                pop     dword[argc]     ; argc
                mov     dword[argvp], esp
                mov     ebx, [argc]
                shl     ebx, 2
                lea     eax, [esp+ebx*4+4]  ; envp
                mov     [envp], eax

                mov     eax, title
                call    OutAsciiZ
                call    NewLine
                mov     eax, SYS_fork
                int     0x80
                cmp     eax, 0
                jne     .parent
                ; child
                mov     eax, child
                call    OutAsciiZ
                call    NewLine
                mov     eax, SYS_execve
                mov     ebx, command    ; (char *)filename
                mov     ecx, argv       ; char ** argv
                mov     edx, [envp]     ; char ** envp
                int     0x80
                call    Exit

    .parent
                push    eax
                mov     ebx, eax        ; pid
                mov     eax, SYS_wait4
                mov     ecx, stat_addr
                mov     edx, WUNTRACED  ; WNOHANG
                mov     esi, ru         ; rusage
                int     0x80

                mov     eax, parent
                call    OutAsciiZ
                pop     eax             ; pid
                call    PrintLeft
                call    NewLine
                mov     eax, timemsg
                call    OutAsciiZ
                mov     eax, [ru + rusage.ru_stime_tv_usec]
                call    PrintLeft
                call    NewLine
                call    NewLine

                mov     eax, title2
                call    OutAsciiZ
                call    NewLine
                mov     eax, SYS_fork
                int     0x80
                cmp     eax, 0
                jne     .parent2
                ; child2
                mov     eax, child
                call    OutAsciiZ
                call    NewLine
                mov     eax, SYS_execve
                mov     ebx, command    ; (char *)filename
                mov     ecx, argv       ; char ** argv
                mov     edx, fakeenvp   ; char ** envp
                int     0x80
                call    Exit

    .parent2
                push    eax
                mov     ebx, eax        ; pid
                mov     eax, SYS_wait4
                mov     ecx, stat_addr
                mov     edx, WUNTRACED  ; WNOHANG
                mov     esi, ru         ; rusage
                int     0x80

                mov     eax, parent
                call    OutAsciiZ
                pop     eax             ; pid
                call    PrintLeft
                call    NewLine
                mov     eax, timemsg
                call    OutAsciiZ
                mov     eax, [ru + rusage.ru_stime_tv_usec]
                call    PrintLeft
                call    NewLine

                call    Exit
;------------------------------------
