;Copyright (C) 2000 Jun Mizutani <mizutani.jun@nifty.ne.jp>
;
; file          : resource.inc
; created       : 2000/07/21
; derived from  : linux-2.2.14/include/linux/resource.h
;                 linux-2.2.14/include/linux/wait.h

%ifndef __RESOURCE_INC
%define __RESOURCE_INC

%include "vartype.inc"

;        struct timeval ru_utime;        user time used
;        struct timeval ru_stime;        system time used
struc  rusage
        .ru_utime_tv_sec   LONG  1; user time used
        .ru_utime_tv_usec  LONG  1;
        .ru_stime_tv_sec   LONG  1; system time used
        .ru_stime_tv_usec  LONG  1;
        .ru_maxrss    LONG   1;  maximum resident set size
        .ru_ixrss     LONG   1;  integral shared memory size
        .ru_idrss     LONG   1;  integral unshared data size
        .ru_isrss     LONG   1;  integral unshared stack size
        .ru_minflt    LONG   1;  page reclaims
        .ru_majflt    LONG   1;  page faults
        .ru_nswap     LONG   1;  swaps
        .ru_inblock   LONG   1;  block input operations
        .ru_oublock   LONG   1;  block output operations
        .ru_msgsnd    LONG   1;  messages sent
        .ru_msgrcv    LONG   1;  messages received
        .ru_nsignals  LONG   1;  signals received
        .ru_nvcsw     LONG   1;  voluntary context switches
        .ru_nivcsw    LONG   1;  involuntary
endstruc

; from include/linux/wait.h
%assign WNOHANG         0x00000001
%assign WUNTRACED       0x00000002

%endif
